{-# LANGUAGE GADTs #-}
{-# LANGUAGE FunctionalDependencies #-}
module Functions where

import Types
import Sources

class (SourceState a, Show f) => IsFunction f a b | f -> a b where
  runF :: f -> a -> b

data IsImageFilename = IsImageFilename deriving (Show)
instance IsFunction IsImageFilename FilePath Bool where
  runF IsImageFilename _path = undefined

data ConvertedImageFilename = ConvertedImageFilename deriving (Show)
instance IsFunction ConvertedImageFilename FilePath FilePath where
  runF ConvertedImageFilename _path = undefined


class (SourceState a, Show f) => IsFunctionIO f a b | f -> a b where
  runFIO :: f -> a -> IO b

data ListDirectory = ListDirectory deriving (Show)
instance IsFunctionIO ListDirectory FilePath [FilePath] where
  runFIO ListDirectory _path = undefined

data OpenImage = OpenImage deriving (Show)
instance IsFunctionIO OpenImage FilePath Image where
  runFIO OpenImage _path = undefined

data ConvertImage = ConvertImage deriving (Show)
instance IsFunctionIO ConvertImage Image Image where
  runFIO ConvertImage _image = undefined

data SaveFile = SaveFile deriving (Show)
instance IsFunctionIO SaveFile (String, FilePath) () where
  runFIO SaveFile _source = undefined

data RunPandoc = RunPandoc deriving (Show)
instance IsFunctionIO RunPandoc String String where
  runFIO RunPandoc _source = undefined
